################################################################
# Convert the calling entity's integer array UUID representation
# into the hyphenated hexadecimal representation.
#
#
# @as = entity
# @at = nd
################################################################


# Cache the player's UUID to prevent multiple data calls
data modify storage uf_data:math.uuid tmp.UUID set from entity @s UUID


#------------------------ FIRST NUMBER ------------------------#
execute \
  store result score $data UF_DATA.uuid.num \
  run data get storage uf_data:math.uuid tmp.UUID[0]
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players get $data UF_DATA.uuid.num 
execute \
  store result storage uf_data:math.uuid tmp.a1 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.a2 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.a3 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.a4 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256


#------------------------ SECOND NUMBER -----------------------#
execute \
  store result score $data UF_DATA.uuid.num \
  run data get storage uf_data:math.uuid tmp.UUID[1]
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players get $data UF_DATA.uuid.num 
execute \
  store result storage uf_data:math.uuid tmp.b1 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.b2 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.b3 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.b4 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256


#------------------------ THIRD NUMBER ------------------------#
execute \
  store result score $data UF_DATA.uuid.num \
  run data get storage uf_data:math.uuid tmp.UUID[2]
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players get $data UF_DATA.uuid.num 
execute \
  store result storage uf_data:math.uuid tmp.c1 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.c2 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.c3 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.c4 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
    

#------------------------ FOURTH NUMBER -----------------------#
execute \
  store result score $data UF_DATA.uuid.num \
  run data get storage uf_data:math.uuid tmp.UUID[3]
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players get $data UF_DATA.uuid.num 
execute \
  store result storage uf_data:math.uuid tmp.d1 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.d2 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result score $data UF_DATA.uuid.bits \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.d3 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.bits %= $data UF_DATA.const.256
execute \
  store result storage uf_data:math.uuid tmp.d4 int 1 \
  run scoreboard players operation $data UF_DATA.uuid.num /= $data UF_DATA.const.256


# Convert decimals to hexadecimal and concat the string fragments
function uf_data:.math/.uuid/convert with storage uf_data:math.uuid tmp
function uf_data:.math/.uuid/to_string with storage uf_data:math.uuid tmp