################################################################
# Establish the data and function context.
#
#
# @as = entity
# @args = {
#   height: float
#   width: float
#   on_attack: string[function]
#   on_interact: string[function]
# }
################################################################


#------------------------ DATA CONTEXT ------------------------#
$data modify storage uf_entity:hitbox summon.input.height set value $(height)
$data modify storage uf_entity:hitbox summon.input.width set value $(width)
$data modify storage uf_entity:hitbox summon.input.on_attack set value "$(on_attack)"
$data modify storage uf_entity:hitbox summon.input.on_interact set value "$(on_interact)"
function uf_api:.data/.math/uuid
data modify storage uf_entity:hitbox summon.input.owner_UUID set from storage uf_data:math.uuid output
#--------------------------------------------------------------#


#---------------------- FUNCTION CONTEXT ----------------------#
execute \
  summon minecraft:marker \
  run function uf_entity:.c_entity/.hitbox/.summon/both \
    with storage uf_entity:hitbox summon.input
#--------------------------------------------------------------#