################################################################
# Central function loop for custom entities.
#
#
# @as = nd
# @at = nd
################################################################


#----------------------- SUMMON MARKER ------------------------#
execute \
  unless score $config UF_CONFIG.replace_summonMarker matches 0 \
  as @e[type=minecraft:marker, tag=UF_ENTITY.SM] \
  at @s \
  run function uf_entity:.invoke/summon \
    with entity @s data
#--------------------------------------------------------------#


#------------------------ DATA MARKER -------------------------#
# Invoke the on_tick functions for all custom entities
execute \
  as @e[type=minecraft:marker, tag=UF_ENTITY.DM, tag=UF_ENTITY.on_tick] \
  at @s \
  run function uf_entity:.invoke/on_tick \
    with entity @s data 
#--------------------------------------------------------------#